#include "pch.h"
#include "findfile.h"
#include <algorithm>

// ļnMaxLimit;
CONST size_t nMaxLimit = 0xFFFFFFFF;	//--4294967295;
// ļĬnDefLimit;
CONST size_t nDefLimit = 0xFFFFF;	//--1048575

// ·ָ;
CONST TCHAR		c_pathSeparator = _T('\\');
CONST TString	s_pathSeparator = _T("\\");
CONST TString	g_sVertical = _T("|");

// ȷչʽ;
// ֵÿԴļinixmlлȡ,ڴд;
CONST TString	g_sCorrectExt = _T("*.jpg|*.jpeg|*.png|*.bmp|*.cr2|*.nef|*.raw");


findfile::findfile(void):
m_nlimit(nDefLimit),
m_pvtfiles(NULL),
m_pvtnames(NULL),
m_pvtfolders(NULL),
m_pvtfiles_sth(NULL),
m_pvtfiles_mth(NULL)
{
	
}

findfile::~findfile(void)
{
}

/************************************************************************/
/*
:match
:жָļǷƥָչ;
:
IN	sFileExt	չ;
IN	sFile		ļ;
:ƥ䷵ط0ֵ,򷵻0;
ע:
*/
/************************************************************************/
void findfile::setlimit(IN CONST INT &nLimit)
{
	if (nLimit < 1)
		m_nlimit = nDefLimit;
	if (nLimit < nMaxLimit)
		m_nlimit = nLimit;
}

// ȡļ;
TString findfile::getfilename(IN CONST TString &file)
{
	TString name;
	TString strfile = file;
	int nIndex = strfile.find_last_of(_T('\\'));	// file '\\' ,òļ;
	if (nIndex == TString::npos)
	{
		nIndex = strfile.find_last_of(_T('.'));
		if ( nIndex == TString::npos )
			return _T("");

		return strfile.substr(0, nIndex);
	}

	name = strfile.substr(nIndex+1);
	nIndex = name.find_last_of(_T('.'));
	if (nIndex == TString::npos)
		return _T("");

	return name.substr(0, nIndex);
}

void findfile::find1st(TString folder, TString &file)
{
	TString path = folder;
	if (path.size() > 0 && c_pathSeparator != path[path.size() - 1])
		path.append(s_pathSeparator);

	TString _file = _T("*");
	TString s = path + _file;

	WIN32_FIND_DATA fileinfo = { 0 };
	HANDLE handle = FindFirstFile(s.c_str(), &fileinfo);

	if (NULL != handle && INVALID_HANDLE_VALUE != handle)
	{
		do
		{
			// '.' '..'ϵͳļȥ;
			if (_T('.') != fileinfo.cFileName[0])
			{
				if ((FILE_ATTRIBUTE_DIRECTORY & fileinfo.dwFileAttributes) != FILE_ATTRIBUTE_DIRECTORY)	// Ŀ¼;
				{
					file = path + fileinfo.cFileName;
					break;
				}
			}
		} while (FindNextFile(handle, &fileinfo));

		FindClose(handle);
	}
}

// ȫ;
void findfile::findall(IN CONST TString& folder)
{
	TString path = folder;
	if (path.size() > 0 && c_pathSeparator != path[path.size() - 1])
		path.append(s_pathSeparator);

	TString file = _T("*");
	TString s = path + file;

	WIN32_FIND_DATA fileinfo = { 0 };
	HANDLE handle = FindFirstFile(s.c_str(), &fileinfo);

	if (NULL != handle && INVALID_HANDLE_VALUE != handle)
	{
		do
		{
			// Ƿ񳬹;
			if (checklimit()) break;

			// '.' '..'ϵͳļȥ;
			if (_T('.') != fileinfo.cFileName[0])
			{
				if ((FILE_ATTRIBUTE_DIRECTORY & fileinfo.dwFileAttributes) == FILE_ATTRIBUTE_DIRECTORY)	// Ŀ¼;
				{
					m_pvtfolders->push_back(path + fileinfo.cFileName);
					findall(path + fileinfo.cFileName);
				}
				else
				{
					if (!checklimit())
					{
						m_pvtnames->push_back(fileinfo.cFileName);
						m_pvtfiles->push_back(path + fileinfo.cFileName);
					}
				}
			}

		} while (FindNextFile(handle, &fileinfo));

		FindClose(handle);
	}
}

void findfile::findsubfolder(IN CONST TString& folder)	// Ŀ¼;
{
	TString path = folder;
	if (path.size() > 0 && c_pathSeparator != path[path.size() - 1])
		path.append(s_pathSeparator);

	TString file = _T("*");
	TString s = path + file;

	WIN32_FIND_DATA fileinfo = { 0 };
	HANDLE handle = FindFirstFile(s.c_str(), &fileinfo);

	if (NULL != handle && INVALID_HANDLE_VALUE != handle)
	{
		do
		{
			if (_T('.') != fileinfo.cFileName[0])// '.' '..'ϵͳļȥ;
			{
				if ((FILE_ATTRIBUTE_DIRECTORY & fileinfo.dwFileAttributes) == FILE_ATTRIBUTE_DIRECTORY)	// Ŀ¼;
				{
					m_pvtfolders->push_back(path + fileinfo.cFileName);
				}
			}
		} while (FindNextFile(handle, &fileinfo));

		FindClose(handle);
	}
}

void findfile::findallsubfolder(IN CONST TString& folder)
{
	TString path = folder;
	if (path.size() > 0 && c_pathSeparator != path[path.size() - 1])
		path.append(s_pathSeparator);

	TString file = _T("*");
	TString s = path + file;

	WIN32_FIND_DATA fileinfo = { 0 };
	HANDLE handle = FindFirstFile(s.c_str(), &fileinfo);

	if (NULL != handle && INVALID_HANDLE_VALUE != handle)
	{
		do
		{
			if (_T('.') != fileinfo.cFileName[0])// '.' '..'ϵͳļȥ;
			{
				if ((FILE_ATTRIBUTE_DIRECTORY & fileinfo.dwFileAttributes) == FILE_ATTRIBUTE_DIRECTORY)	// Ŀ¼;
				{
					m_pvtfolders->push_back(path + fileinfo.cFileName);
					findallsubfolder(path + fileinfo.cFileName); // Ŀ¼;
				}
			}
		} while (FindNextFile(handle, &fileinfo));

		FindClose(handle);
	}
}

//////////////////////////////////////////////////////////////////////////
void findfile::findfiles_findin_subfolder(IN CONST TString& folder)
{
	TString path = folder;
	if (path.size() > 0 && c_pathSeparator != path[path.size() - 1])
		path.append(s_pathSeparator);

	TString file = _T("*");
	TString s = path + file;

	WIN32_FIND_DATA fileinfo = { 0 };
	HANDLE handle = FindFirstFile(s.c_str(), &fileinfo);

	if (NULL != handle && INVALID_HANDLE_VALUE != handle)
	{
		do
		{
			// Ƿ񳬹;
			if (checklimit()) break;

			// '.' '..'ϵͳļȥ;
			if (_T('.') != fileinfo.cFileName[0])
			{
				if ((FILE_ATTRIBUTE_DIRECTORY & fileinfo.dwFileAttributes) == FILE_ATTRIBUTE_DIRECTORY)	// Ŀ¼;
				{
					findfiles_findin_subfolder(path + fileinfo.cFileName);
				}
				else
				{
					if (!checklimit())
					{
						m_pvtfiles->push_back(path + fileinfo.cFileName);
					}
				}
			}
		} while (FindNextFile(handle, &fileinfo));

		FindClose(handle);
	}
}

void findfile::findfiles_findout_subfolder(IN CONST TString& folder)
{
	TString path = folder;
	if (path.size() > 0 && c_pathSeparator != path[path.size() - 1])
		path.append(s_pathSeparator);

	TString file = _T("*");
	TString s = path + file;

	WIN32_FIND_DATA fileinfo = { 0 };
	HANDLE handle = FindFirstFile(s.c_str(), &fileinfo);

	if (NULL != handle && INVALID_HANDLE_VALUE != handle)
	{
		do
		{
			// Ƿ񳬹;
			if (checklimit()) break;

			// '.' '..'ϵͳļȥ;
			if (_T('.') != fileinfo.cFileName[0])
			{
				if ((FILE_ATTRIBUTE_DIRECTORY & fileinfo.dwFileAttributes) != FILE_ATTRIBUTE_DIRECTORY)	// Ŀ¼;
				{
					if (!checklimit())
					{
						m_pvtfiles->push_back(path + fileinfo.cFileName);
					}
				}
			}
		} while (FindNextFile(handle, &fileinfo));

		FindClose(handle);
	}
}

void findfile::findfiles_within_subfolder(IN CONST TString& folder)
{
	TString path = folder;
	if (path.size() > 0 && c_pathSeparator != path[path.size() - 1])
		path.append(s_pathSeparator);

	TString file = _T("*");
	TString s = path + file;

	WIN32_FIND_DATA fileinfo = { 0 };
	HANDLE handle = FindFirstFile(s.c_str(), &fileinfo);

	if (NULL != handle && INVALID_HANDLE_VALUE != handle)
	{
		do
		{
			// Ƿ񳬹;
			if (checklimit()) break;

			// '.' '..'ϵͳļȥ;
			if (_T('.') != fileinfo.cFileName[0])
			{
				if ((FILE_ATTRIBUTE_DIRECTORY & fileinfo.dwFileAttributes) == FILE_ATTRIBUTE_DIRECTORY)	// Ŀ¼;
				{
					m_pvtfolders->push_back(path + fileinfo.cFileName);
					findfiles_within_subfolder(path + fileinfo.cFileName);
				}
				else
				{
					if (!checklimit())
					{
						m_pvtfiles->push_back(path + fileinfo.cFileName);
					}
				}
			}
		} while (FindNextFile(handle, &fileinfo));

		FindClose(handle);
	}
}
