/************** Begin of GlobalMacro.h *******************************************/
/**********************************************************
* Ȩ (C)2008, 51.com
*
* ļƣGlobalMacro.h
* ժҪȫֺ궨ͷļ
*			ļҪõȫֺĶ
* ˵
* ǰ汾
*     ߣ»
* ڣ2009-1-02
*
* ޸ļ¼1
*    ޸ڣ
*      ţ
*      ˣ
*    ޸ݣ
**********************************************************/
#if !defined(AFX_GLOBALMACRO_H__DD58A78D_C125_410F_B4C8_F0067B797121__INCLUDED_)
#define AFX_GLOBALMACRO_H__DD58A78D_C125_410F_B4C8_F0067B797121__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

// ȡά [7/1/2008 »]
#define PARRAYSIZE(array) ((sizeof(array)/sizeof(array[0])))

/** Declare all the standard PWlib class information.
This macro is used to provide the basic run-time typing capability needed
by the library. All descendent classes from the #PObject# class require
these functions for correct operation. Either use ptrThis macro or the
#PDECLARE_CLASS# macro.

The use of the #PDECLARE_CLASS# macro is no longer recommended for reasons
of compatibility with documentation systems.
*/
#define CLASSINFO(cls, par) \
  public: \
	static const char * Class() \
	{ return #cls; } \
	virtual const char * GetClass(unsigned ancestor = 0) const \
	{ return ancestor > 0 ? par::GetClass(ancestor-1) : cls::Class(); } \
	virtual BOOL IsClass(const char * clsName) const \
	{ return strcmp(clsName, cls::Class()) == 0; } \
	virtual BOOL IsDescendant(const char * clsName) const \
	{ return strcmp(clsName, cls::Class()) == 0 || \
	  par::IsDescendant(clsName); } 


/** Declare all the standard PWlib class information.
This macro is used to provide the basic run-time typing capability needed
by the library. All descendent classes from the #PObject# class require
these functions for correct operation. Either use ptrThis macro or the
#PDECLARE_CLASS# macro.

The use of the #PDECLARE_CLASS# macro is no longer recommended for reasons
of compatibility with documentation systems.
*/
#define CLASSINFO_BASE(cls) \
  public: \
	static const char * Class() \
	{ return #cls; } \
	virtual const char * GetClass(unsigned ancestor = 0) const \
	{ return cls::Class(); } \
	virtual BOOL IsClass(const char * clsName) const \
	{ return strcmp(clsName, cls::Class()) == 0; } \
	virtual BOOL IsDescendant(const char * clsName) const \
	{ return strcmp(clsName, cls::Class()) == 0; } 


/* ػ״̬Ϣ  */
#ifdef OK
#undef OK
#endif /* #ifdef OK */
#ifndef OK
#define OK               (0)    /* ɹ	*/
#endif /* #ifndef OK */

/* ػ״̬Ϣ  */
#ifdef FAILURE
#undef FAILURE
#endif /* #ifdef FAILURE */
#ifndef FAILURE
#define FAILURE           (-1)    /* ʧܷ	*/
#endif /* #ifndef FAILURE */

//////////////////////////////////////////////////////////////////////////
///һЩ궨

///ɾһָĺ궨
//lint -emacro(774, DELETEA)
#ifndef DELETEA
#define DELETEA(ptr) \
	if(NULL != ptr) \
	{ \
		delete[] ptr; \
		ptr = NULL; \
	}
#endif

///ɾһָĺ궨
#ifndef FREEP
#define FREEP(ptr)		\
	if(NULL != ptr)		\
	{					\
		free(ptr) ;		\
		ptr = NULL;		\
	}
#endif

///ɾһָĺ궨
//lint -emacro(774, DELETEP)
#define DELETEP(ptr)	\
	if(NULL != (ptr))		\
	{					\
		delete (ptr);		\
		(ptr) = NULL;		\
	}

///ɾһGDIĺ궨
//lint -emacro(774, DELETEOBJECT)
#define DELETEOBJECT(ptr)	\
	if(NULL != (ptr))		\
	{					\
		::DeleteObject (ptr);		\
		(ptr) = NULL;		\
	}

///DestroyһWindow
//lint -emacro(774, DESTROYWINDOW)
#define DESTROYWINDOW(hWnd)	\
	if (IsWindow(hWnd)) \
	{ \
		DestroyWindow(hWnd); \
	}

///ɾһָĺ궨
//lint -emacro(774, FREEP)
#undef  FREEP
#define FREEP(ptr)		\
	if(NULL != ptr)		\
	{					\
		free(ptr) ;		\
		ptr = NULL;		\
	}


/** ĸɾͬ͵ָĺ궨
*/
#define DELETE_TYPE_P(Type, ptrEvent) \
	{\
		Type *ptrEventLocal = (Type *)ptrEvent; \
		DELETEP(ptrEventLocal); \
		ptrEvent = NULL; \
	}


/** This macro is used to assert that a condition must be TRUE.
conditionִstatement䣬Ȼreturn_valueֵreturn
*/
#define PAssert_ReturnWithValue(condition, return_value) \
	{  \
		if (!(condition)) \
		{ \
			return (return_value); \
		} \
	}

/** This macro is used to assert that a condition must be TRUE.
conditionִstatement䣬Ȼreturn
*/
#define PAssert_Return(condition) \
	{  \
		if (!(condition)) \
		{ \
			return ; \
		} \
	}

#ifndef VOS_DELETE_SEM
#define VOS_DELETE_SEM(semId)	\
	if (NULL != semId)			\
	{							\
		VOS_DeleteSem(semId);	\
		semId = NULL;			\
	}
#endif

/** This macro is used to assert that a condition must be TRUE.
conditionִstatement䣬Ȼreturn_valueֵreturn
*/
#define PAssert_Statement_ReturnWithValue(condition, statement, return_value) \
	{  \
		if (!(condition)) \
		{ \
			statement; \
			return (return_value); \
		} \
	}

/** This macro is used to assert that a condition must be TRUE.
conditionִstatement䣬Ȼreturn
*/
#define PAssert_Statement_Return(condition, statement) \
	{  \
		if (!(condition)) \
		{ \
			statement; \
			return ; \
		} \
	}

/** This macro is used to assert that a pointer must be non-null.
ָptrΪNULLִstatement䣬Ȼreturn_valueֵreturn
*/
#define PAssertNotNull_Statement_ReturnWithValue(ptr, statement, return_value) \
	{ \
		if( (ptr) == NULL) \
		{ \
			statement; \
			return (return_value); \
		} \
	}


/** This macro is used to assert that a pointer must be non-null.
ָptrΪNULLִstatement䣬Ȼreturn
*/
#define PAssertNotNull_Statement_Return(ptr, statement) \
	{ \
		if( (ptr) == NULL) \
		{ \
			statement; \
			return ; \
		} \
	}

/** This macro is used to assert that a pointer must be non-null.
ָptrΪNULLִstatement䣬Ȼreturn_valueֵreturn
*/
#define PAssertNotNull_ReturnWithValue(ptr, return_value) \
	{ \
		if( (ptr) == NULL) \
		{ \
			return (return_value); \
		} \
	}


/** This macro is used to assert that a pointer must be non-null.
ָptrΪNULLִstatement䣬Ȼreturn
*/
#define PAssertNotNull_Return(ptr) \
	{ \
		if( (ptr) == NULL) \
		{ \
			return ; \
		} \
	}

/** This macro is used to do something and return 
ִһstatementȻreturn return_value
*/
#define PStatement_Return(statement, return_value) \
{ \
	statement; \
	return return_value; \
}

/** This macro is used to assert that a condition must be TRUE.
conditionִbreak
*/
#define PAssert_Break(condition) \
{  \
	if (!(condition)) \
	{ \
		break ; \
	} \
}

/** This macro is used to do something and break 
ִһstatementȻbreak
*/
#define PStatement_Break(statement) \
{ \
	statement; \
	break; \
}

/** This macro is used to assert that a condition must be TRUE.
conditionִstatement䣬Ȼִbreak
*/
#define PAssert_Statement_Break(condition, statement) \
{  \
	if (!(condition)) \
	{ \
		statement; \
		break ; \
	} \
}

/** ղ
*/
#define NULL_OPERATION

// ȡά 
#define PARRAYSIZE(array) ((sizeof(array)/sizeof(array[0])))

/** Declare all the standard RTTI class information.
This macro is used to provide the basic run-time typing capability needed
by the library. All descendent classes from the #PObject# class require
these functions for correct operation. Either use ptrThis macro or the
#PDECLARE_CLASS# macro.

The use of the #PDECLARE_CLASS# macro is no longer recommended for reasons
of compatibility with documentation systems.
*/
#define CLASSINFO(cls, par) \
  public: \
	static const char * Class() \
	{ return #cls; } \
	virtual const char * GetClass(unsigned ancestor = 0) const \
	{ return ancestor > 0 ? par::GetClass(ancestor-1) : cls::Class(); } \
	virtual BOOL IsClass(const char * clsName) const \
	{ return strcmp(clsName, cls::Class()) == 0; } \
	virtual BOOL IsDescendant(const char * clsName) const \
	{ return strcmp(clsName, cls::Class()) == 0 || \
	par::IsDescendant(clsName); } 


///memsetȱʡ캯
#ifndef MEMSET_CONSTRUCTOR
#define MEMSET_CONSTRUCTOR(ClassType) \
	ClassType() \
	{ \
		memset(this, 0, sizeof(ClassType)); \
	}
#endif

#if 0
#ifdef __cplusplus
/** 
ضɾ͵ָ
*/
#ifndef DELETE_ARRAY_TEMPLATE
#define DELETE_ARRAY_TEMPLATE
template <class classType>
void DeleteArray(void *&ptr)
{
	classType *ptrClassType = (classType *)ptr;
	DELETEA(ptrClassType);
	ptr = NULL;
}
#endif

/** 
ضɾ͵ָ
*/
#ifndef DELETE_TEMPLATE
#define DELETE_TEMPLATE
template <class classType>
void Delete(void *&ptr)
{
	classType *ptrClassType = (classType *)ptr;
	DELETEP(ptrClassType);
	ptr = NULL;
}
#endif
#endif
#endif


#endif // !defined(AFX_GLOBALMACRO_H__DD58A78D_C125_410F_B4C8_F0067B797121__INCLUDED_)

/************** End of GlobalMacro.h *******************************************/