﻿// pch.h: 这是预编译标头文件。
// 下方列出的文件仅编译一次，提高了将来生成的生成性能。
// 这还将影响 IntelliSense 性能，包括代码完成和许多代码浏览功能。
// 但是，如果此处列出的文件中的任何一个在生成之间有更新，它们全部都将被重新编译。
// 请勿在此处添加要频繁更新的文件，这将使得性能优势无效。

#ifndef PCH_H
#define PCH_H

// 添加要在此处预编译的标头
#include "framework.h"

//////////////////////////////////////////////////////////////////////////
// 用例;
extern HMODULE g_hdll;
extern BOOL LoadLogLibarary();
extern void FreeLogLibarary();

typedef DWORD(*irc_IsAppRunning)(LPCTSTR lpszAppDir);
typedef bool (*irc_StartIRApp)(LPCTSTR lpszAppDir, LPCTSTR lpSignalXml, DWORD dwPort);
typedef bool (*irc_CloseApp)();
typedef bool (*irc_Connect)(LPCTSTR lpServer, int port);
typedef bool (*irc_loadSignalDataSet)(LPCTSTR lpDatasetXml);
typedef LPCTSTR(*irc_getDeviceNames)();
typedef LPCTSTR(*irc_getSignalsName)();
typedef bool (*irc_sendSignal)(LPCTSTR lpSignal, int send_times, int sleep_time);
typedef bool (*irc_sendSignals)(LPCTSTR lpSignals, int sleep_time);
typedef bool (*irc_sendRepeatsSignal)(LPCTSTR lpSignal, int repeat_time);

extern int g_nIRControl;
extern irc_IsAppRunning g_IsAppRunning;
extern irc_StartIRApp g_StartIRApp;
extern irc_CloseApp g_CloseApp;
extern irc_Connect g_Connect;
extern irc_getDeviceNames g_getDeviceNames;
extern irc_getSignalsName g_getSignalsName;
extern irc_loadSignalDataSet g_loadSignalDataSet;
extern irc_sendSignal g_sendSignal;
extern irc_sendSignals g_sendSignals;
extern irc_sendRepeatsSignal g_sendRepeatsSignal;

#endif //PCH_H
